VERSION 5.00
Begin VB.Form Form1 
   Caption         =   ".tsc Encoder/Decoder  -  Drag files on!"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Function InStrRev2(str As String, lookfor As String) As Long
    Dim I As Long
    For I = Len(str) To 1 Step -1
        If Mid(str, I, 1) = lookfor Then Exit For
    Next
    InStrRev2 = I
End Function

Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim I
    Dim InFile As String, OutFile As String, basename As String
    Dim msg As VbMsgBoxResult
    Dim error As Integer
    For I = 1 To Data.Files.Count
        InFile = Data.Files(I)
        Dim DotPos As Long
        DotPos = InStrRev2(InFile, ".")
        If DotPos > 0 Then
            basename = Left(InFile, DotPos - 1)
        Else
            basename = InFile
        End If
        If LCase(Right(InFile, 3)) = "txt" Then
            OutFile = basename + ".tsc"
            EncodeTsc InFile, OutFile
        Else
            OutFile = basename + ".txt"
            DecodeTsc InFile, OutFile
        End If
    Next
    
End Sub

Sub DecodeTsc(InFile As String, OutFile As String)
    Dim Cypher As Byte
    Dim CypherPos As Long
    Dim I As Long
    Dim L As Long
    Dim File() As Byte
    Open InFile For Binary Access Read As #1
        L = LOF(1)
        ReDim File(L - 1)
        Get #1, , File
    Close #1
    CypherPos = (L And &HFFFFFFE) \ 2
    Cypher = File(CypherPos)
    For I = 0 To L - 1
        File(I) = (256 + File(I) - Cypher) And 255
    Next
    File(CypherPos) = Cypher
    
    Open OutFile For Output As #2
    Close #2
    Open OutFile For Binary Access Write As #2
        Put #2, , File
    Close #2
End Sub

Sub EncodeTsc(InFile As String, OutFile As String)
    Dim Cypher As Byte
    Dim CypherPos As Long
    Dim I As Long
    Dim L As Long
    Dim File() As Byte
    Open InFile For Binary Access Read As #1
        L = LOF(1)
        ReDim File(L - 1)
        Get #1, , File
    Close #1
    CypherPos = (L And &HFFFFFFE) \ 2
    Cypher = File(CypherPos)
    For I = 0 To L - 1
        File(I) = (256 + File(I) + Cypher) And 255
    Next
    File(CypherPos) = Cypher
    
    Open OutFile For Output As #2
    Close #2
    Open OutFile For Binary Access Write As #2
        Put #2, , File
    Close #2
End Sub

